import { EventArgs, IList$1, Base, Type, IEnumerable$1, Point } from "igniteui-angular-core";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { Series } from "./Series";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { IHasCategoryAxis } from "./IHasCategoryAxis";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { Brush } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { List$1 } from "igniteui-angular-core";
import { Dictionary$2 } from "igniteui-angular-core";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { CalculatedColumn } from "./CalculatedColumn";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { RenderSurface } from "./RenderSurface";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
/**
 * @hidden
 */
export declare class FinancialEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: number, b: number, c: FinancialCalculationDataSource, d: FinancialCalculationSupportingCalculations, e: FinancialSeries);
    private _position;
    position: number;
    private _count;
    count: number;
    private _dataSource;
    dataSource: FinancialCalculationDataSource;
    private _supportingCalculations;
    supportingCalculations: FinancialCalculationSupportingCalculations;
    private _basedOn;
    basedOn: IList$1<string>;
}
/**
 * @hidden
 */
export declare class FinancialBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected a: FinancialSeriesView;
    constructor(a: FinancialSeriesView);
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    c: number;
    d: number;
    b: number;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    e(a: number): void;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class FinancialSeries extends Series implements IHasCategoryAxis, IHasCategoryModePreference {
    static $t: Type;
    iu(a: SeriesView): void;
    mo: FinancialSeriesView;
    protected get_cr(): boolean;
    ag(): Axis[];
    fs(a: any, b: string): any;
    protected n8(): number;
    private n6;
    ah(a: Point): Point[][];
    ai(a: Point): Point[][];
    constructor();
    pe: Brush;
    k9(): Brush;
    ht(): void;
    l8: CategoryAxisBase;
    mt: NumericYAxis;
    oo: string;
    m2: IFastItemColumn$1<number>;
    private m1;
    of: string;
    my: IFastItemColumn$1<number>;
    private mx;
    ok: string;
    m0: IFastItemColumn$1<number>;
    private mz;
    oc: string;
    mw: IFastItemColumn$1<number>;
    private mv;
    os: string;
    m5: IFastItemColumn$1<number>;
    private m4;
    ne: boolean;
    protected m8: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    protected ng(): boolean;
    protected o0(a: AssigningCategoryStyleEventArgs): void;
    protected mg: CategorySeriesRenderManager;
    protected oy(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    ny(a: Point): number;
    fe(a: Point, b: boolean): number;
    fc(a: Point, b: boolean): number;
    d9(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    ll(a: Point, b: boolean, c: boolean): Point;
    en(a: Point, b: boolean, c: boolean): number;
    ej(a: Point, b: boolean, c: boolean): number;
    el(a: Point, b: boolean, c: boolean): number;
    n0(a: Point, b: boolean, c: boolean): number;
    n1(a: Point, b: boolean, c: boolean): number;
    n2(a: Point, b: boolean, c: boolean): number;
    lh(a: Point, b: boolean, c: boolean): Point;
    lj(a: Point, b: boolean, c: boolean): Point;
    pg(a: Point, b: boolean, c: boolean): Point;
    pf(a: Point, b: boolean, c: boolean): Point;
    ph(a: Point, b: boolean, c: boolean): Point;
    ib(): void;
    protected jt(a: Rect, b: Rect): void;
    protected js(a: Rect, b: Rect): void;
    protected nj: Dictionary$2<IFastItemColumn$1<number>, string>;
    protected nk: Dictionary$2<string, string>;
    private m3;
    private ox;
    private m7;
    protected iz(a: any, b: string, c: any, d: any): void;
    na(a: any): boolean;
    m9(a: any): boolean;
    protected l1(a: number, b: number, c: Axis): any[];
    protected n5(a: SeriesView): number;
    protected n7(a: SeriesView): number;
    l0(a: number, b: number): any[];
    private mr;
    protected get_nc(): boolean;
    protected readonly nc: boolean;
    protected get_cv(): boolean;
    at(a: any, b: Point): HighlightingInfo;
    n9(a: Point): number;
    protected mq(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected mp(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected nb(): boolean;
    eb(a: Point): number;
    e8(a: Point): number;
    protected get_c1(): boolean;
    ap(): CategoryAxisBase;
    fa(a: Point): number;
    fp(a: Point): any;
    mb: CategoryFrame;
    md: CategoryFrame;
    ma: CategoryFrame;
    protected nz(a: Rect, b: Rect, c: Rect): number;
    mi: CategoryTransitionInMode;
    nf: boolean;
    protected dc(): boolean;
    protected mh(): CategoryTransitionInMode;
    protected bo(): TransitionInSpeedType;
    o1(a: CategoryFrame, b: FinancialSeriesView): void;
    oz(a: CategoryFrame, b: FinancialSeriesView): void;
    dw(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    mj: CategoryTransitionSourceFramePreparer;
    n3(a: FinancialSeriesView): number;
    protected hw(): void;
    je(a: boolean): void;
    typical: (sender: any, e: FinancialEventArgs) => void;
    typicalBasedOn: (sender: any, e: FinancialEventArgs) => void;
    protected nh(a: IList$1<string>): boolean;
    readonly ni: boolean;
    protected nd(): boolean;
    protected ow(a: FinancialEventArgs): void;
    protected readonly nq: IEnumerable$1<number>;
    private _nn;
    private nn;
    protected readonly np: IEnumerable$1<number>;
    private _nm;
    private nm;
    protected readonly no: IEnumerable$1<number>;
    private _nl;
    private nl;
    ns(a: IList$1<number>): IList$1<number>;
    private m6;
    protected nr(): IList$1<string>;
    private nw;
    getOpenColumnAsArray(): number[];
    private nu;
    getHighColumnAsArray(): number[];
    private nv;
    getLowColumnAsArray(): number[];
    private nt;
    getCloseColumnAsArray(): number[];
    private nx;
    getVolumeColumnAsArray(): number[];
    protected hy(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected mk(a: number, b: number): FinancialCalculationDataSource;
    n4(a: number): number;
    protected ml(a: FinancialCalculationDataSource): FinancialCalculationSupportingCalculations;
    readonly categoryAxis: CategoryAxisBase;
    private mc;
    jf(a: Rect, b: RenderSurface): void;
    private l9;
    jc(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    am(a: Axis): Axis;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    private me;
    mf: CategoryMode;
    protected get_cz(): boolean;
    ji(a: Brush, b: Brush): void;
    private o2;
    private ms;
    private mu;
    fr(a: any): any;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinancialCalculationSupportingCalculations extends Base {
    static $t: Type;
    a: ColumnSupportingCalculation;
    c: ColumnSupportingCalculation;
    d: ColumnSupportingCalculation;
    b: ColumnSupportingCalculation;
    h: DataSourceSupportingCalculation;
    f: DataSourceSupportingCalculation;
    g: DataSourceSupportingCalculation;
    e: DataSourceSupportingCalculation;
    k: (arg1: (arg1: number) => number, arg2: number, arg3: number) => IEnumerable$1<number>;
    j: (arg1: (arg1: number) => number, arg2: number) => IEnumerable$1<number>;
    i: (arg1: number) => number;
}
/**
 * @hidden
 */
export declare class DataSourceSupportingCalculation extends SupportingCalculation$1<(dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>> {
    static $t: Type;
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>);
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>, c: IList$1<string>);
    constructor(a: number, ..._rest: any[]);
}
/**
 * @hidden
 */
export declare class FinancialCalculationDataSource extends Base {
    static $t: Type;
    private _openColumn;
    openColumn: IList$1<number>;
    private _closeColumn;
    closeColumn: IList$1<number>;
    private _highColumn;
    highColumn: IList$1<number>;
    private _lowColumn;
    lowColumn: IList$1<number>;
    private _volumeColumn;
    volumeColumn: IList$1<number>;
    private _indicatorColumn;
    indicatorColumn: IList$1<number>;
    private _typicalColumn;
    typicalColumn: CalculatedColumn;
    private _trueRange;
    trueRange: CalculatedColumn;
    private _trueLow;
    trueLow: CalculatedColumn;
    private _period;
    period: number;
    private _shortPeriod;
    shortPeriod: number;
    private _longPeriod;
    longPeriod: number;
    private _count;
    count: number;
    private _calculateFrom;
    calculateFrom: number;
    private _calculateCount;
    calculateCount: number;
    private _multiplier;
    multiplier: number;
    private _minimumValue;
    minimumValue: number;
    private _maximumValue;
    maximumValue: number;
    private _specifiesRange;
    specifiesRange: boolean;
    private _series;
    series: FinancialSeries;
}
/**
 * @hidden
 */
export declare abstract class FinancialSeriesView extends SeriesView {
    static $t: Type;
    bw: FinancialSeries;
    bu: FinancialBucketCalculator;
    by: number;
    bx(a: CategoryFrame): boolean;
    bz(a: CategoryFrame): void;
    constructor(a: FinancialSeries);
    protected abstract bv(): FinancialBucketCalculator;
    ap(): void;
    getDefaultTooltipTemplate(): string;
    protected ac(): void;
}
